//#include "splines.inc"
//#include "meshes.inc"

//global_settings{assumed_gamma 1 max_trace_level 20}
//sky_sphere{pigment{gradient y color_map{[0 rgb .4][1 rgb z*.2]}scale 2 translate -1}}

//#declare Petal_Texture=texture{pigment{rgb x*.5 transmit 0} /*finish{specular .02 roughness .1}*/}
//#declare Stem_Texture=texture{pigment{rgb y*.7}}
//#declare Green_Texture=texture{pigment{rgb <.02,.01,0>} normal{bozo .2 scale .2} finish{specular .02 roughness .1}}

#declare Petal_Top_Side = array[4]
{
  <0,.05,0>,<0,.3,1>,
  <0,-.5,4.5>,<0,-.5,.1>
}

#declare Petal_Left_Side = array[6]
{
  <-.2,0,  0>,<-.4,0,1>,
  <-.6,0,2.75>,<-.1,0,1>,
  <  0,-.5,4.5>,<.3,0,0>
}

//Create half
#declare Petal_Array = Connect_BSplines(Petal_Top_Side,Petal_Left_Side,15,30) //array[Span_Detail][Spline_Detail]

//Macro for addition
#macro _Normal_Addition_Macro(X,Z)
 (sin(radians(X*180))*sqrt(1-Z))
#end
//Add Normals
Add_Normals(Petal_Array,.15)

//Enlargen Mesh with mirror, calculate the normals, make the mesh...
Mirror_Mesh_Dat(Petal_Array,<1,0,0>)
#declare Normal_Array=Make_Normals(Petal_Array)
#if (Mesh_Type=0)
#declare Petal=Make_Mesh(Petal_Array)
#else
#declare Petal=Make_Smooth_Mesh(Petal_Array,Normal_Array)
#end
//#declare Petal=union{Make_Grid(Petal_Array,.02) texture{Petal_Texture}}

//#declare Petal=object{Petal texture{Petal_Texture}}
//object{Petal translate x*-1}
//object{Petal rotate z*90 translate x*1}



#declare TPetal_Top_Side = array[4]
{
  <0,.05,0>,<0,.3,1>,
  <0,-.25,4.5>,<0,-.25,.1>
}

#declare TPetal_Left_Side = array[6]
{
  <-.2,0,  0>,<-.4,0,1>,
  <-.6,0,2.75>,<-.1,0,1>,
  <  0,-.25,4.5>,<.3,0,0>
}

//Create half
#declare TPetal_Array = Connect_BSplines(TPetal_Top_Side,TPetal_Left_Side,5,10) //array[Span_Detail][Spline_Detail]

//Macro for addition
#macro _Normal_Addition_Macro(X,Z)
 (sin(radians(X*180))*sqrt(1-Z))
#end
//Add Normals
Add_Normals(TPetal_Array,.05)

//Enlargen Mesh with mirror, calculate the normals, make the mesh...
Mirror_Mesh_Dat(TPetal_Array,<1,0,0>)
#declare Normal_Array=Make_Normals(TPetal_Array)
#if (Mesh_Type=0)
#declare TPetal=Make_Mesh(TPetal_Array)
#else
#declare TPetal=Make_Smooth_Mesh(TPetal_Array,Normal_Array)
#end

//#declare TPetal=object{TPetal texture{Petal_Texture}}
//object{TPetal translate x*-1}
//object{TPetal rotate z*90 translate x*1}

 
 /***********Base************/
 
#declare Base_Top_Side = array[6]
{
  <0,.05,0>,<0,.3,.2>,
  <0,-.3,1.4>,<0,0,.5>,
  <0,-1.5,4.5>,<0,-1.5,-.5>
}
#declare Base_Left_Side = array[6]
{
  <-.2,.05,0>,<0,.3,.2>,
  <-.5,-.3,1.4>,<0,0,.5>,
  <0,-1.5,4.5>,<0,-1.5,-.5>
}


//Create half
#declare Base_Array = Connect_BSplines(Base_Top_Side,Base_Left_Side,15,20) //array[Span_Detail][Spline_Detail]

//Macro for addition
#macro _Normal_Addition_Macro(X,Z)
 (sin(radians(X*180))*sqrt(1-Z))
#end
//Add Normals
Add_Normals(Base_Array,.05)

//Enlargen Mesh with mirror, calculate the normals, make the mesh...
Mirror_Mesh_Dat(Base_Array,<1,0,0>)
#declare Normal_Array=Make_Normals(Base_Array)
#declare Base=Make_Smooth_Mesh(Base_Array,Normal_Array)
//#declare Petal=Make_Mesh(Petal_Array)
//#declare Petal=union{Make_Grid(Petal_Array,.02) texture{Petal_Texture}}

//#declare Base=object{Base texture{Base_Texture}}

